/* -*-java-*- talog.java */

import java.io.*;

public class talog
{
    // shorthands to avoid the need for fully-qualified names, sigh...
    private static double ABS(double x)			{ return (elefunt.ABS(x)); }
    private static double ALOG(double x)		{ return (elefunt.ALOG(x)); }
    private static double ALOG10(double x)		{ return (elefunt.ALOG10(x)); }
    private static double AMAX1(double x,double y)	{ return (elefunt.AMAX1(x,y)); }
    private static double RAN()				{ return (elefunt.RAN()); }
    private static double SIGN(double x,double y)	{ return (elefunt.SIGN(x,y)); }
    private static double SQRT(double x)		{ return (elefunt.SQRT(x)); }
    private static double TO_FP_T(long n)		{ return (elefunt.TO_FP_T(n)); }

    public static void talog()
    {
	/*#     program to test alog
	#
	#     data required
	#
	#        none
	#
	#     subprograms required from this package
	#
	#        machar - an environmental inquiry program providing
	#                 information on the floating-point arithmetic
	#                 system.  note that the call to machar can
	#                 be deleted provided the following four
	#                 parameters are assigned the values indicated
	#
	#                 ibeta - the radix of the floating-point system
	#                 it    - the number of base-ibeta digits in the
	#                         significand of a floating-point number
	#                 xmin  - the smallest non-vanishing floating-point
	#                         power of the radix
	#                 xmax  - the largest finite floating-point no.
	#
	#        ran(k) - a function subprogram returning random real
	#                 numbers uniformly distributed over (0,1)
	#
	#
	#     standard fortran subprograms required
	#
	#         abs, alog, alog10, amax1, float, sign, sqrt
	#
	#
	#     latest revision - december 6, 1979
	#
	#     author - w. j. cody
	#              argonne national laboratory
	#
	#*/

	final double ait = TO_FP_T(machar.it);
	final double beta = TO_FP_T(machar.ibeta);
	final double albeta = ALOG(beta);
	final double eight = 8.0e0;
	final double half = 0.5e0;
	final double tenth = 0.1e0;
	final double ONE = elefunt.ONE;
	final double ZERO = elefunt.ZERO;

	int i,
	    j,
	    k1,
	    k2,
	    k3,
	    n;

	double
	    a,
	    b,
	    c,
	    del,
	    r6,
	    r7,
	    w,
	    x,
	    xl,
	    xn,
	    x1,
	    y,
	    z,
	    zz;

	elefunt.banner("talog");

	ran.ranset(initseed.initseed());

	j = machar.it / 3;
	c = ONE;

	for (i = 1; i <= j; ++i)
	    c = c / beta;

	b = ONE + c;
	a = ONE - c;
	n = (int)maxtest.maxtest();
	xn = TO_FP_T(n);

	/* random argument accuracy tests */

	for (j = 1; j <= 4; ++j)
	{
	    k1 = 0;
	    k3 = 0;
	    x1 = ZERO;
	    r6 = ZERO;
	    r7 = ZERO;
	    del = (b - a) / xn;
	    xl = a;

	    for (i = 1; i <= n; ++i)
	    {
		x = del * RAN() + xl;
		if (j == 1)
		{
		    y = (x - half);
		    y -= half;
		    zz = ALOG(x);
		    z = ONE / 3.0e0;
		    z = y * (z - y / 4.0e0);
		    z = (z - half) * y * y + y;
		}
		else if (j == 2)
		{
		    x += eight;
		    x -= eight;
		    y = x + x / 16.0e0;
		    z = ALOG(x);
		    zz = ALOG(y) - 7.7746816434842581e-5;
		    zz = zz - 31.0e0 / 512.0e0;
		}
		else
		if (j != 3)
		{
		    z = ALOG(x * x);
		    zz = ALOG(x);
		    zz = zz + zz;
		}
		else
		{
		    x += eight;
		    x -= eight;
		    y = x + x * tenth;
		    z = ALOG10(x);
		    zz = ALOG10(y) - 3.7706015822504075e-4;
		    zz = zz - 21.0e0 / 512.0e0;
		}
		w = ONE;
		if (z != ZERO)
		    w = (z - zz) / z;
		z = SIGN(w, z);
		if (z > ZERO)
		    k1 = k1 + 1;
		if (z < ZERO)
		    k3 = k3 + 1;
		w = ABS(w);
		if (w > r6)
		{
		    r6 = w;
		    x1 = x;
		}
		r7 = r7 + w * w;
		xl = xl + del;
	    }

	    k2 = n - k3 - k1;
	    r7 = SQRT(r7 / xn);
	    if (j == 1)
		System.out.print("1TEST OF ALOG(X) VS T.S. EXPANSION OF ALOG(1+Y)\n\n\n");
	    else if (j == 2)
		System.out.print("1TEST OF ALOG(X) VS ALOG(17X/16)-ALOG(17/16)\n\n\n");
	    else if (j == 3)
		System.out.print("1TEST OF ALOG10(X) VS ALOG10(11X/10)-ALOG10(11/10)\n\n\n");
	    else if (j == 4)
		System.out.print("1TEST OF ALOG(X*X) VS 2 * LOG(X)\n\n\n");
	    if (j == 1)
	    {
		System.out.print(fmt.I(n,7) + " RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL\n");
		System.out.print("      (1-EPS,1+EPS), WHERE EPS =" + fmt.E(c,15,4) + "\n\n\n");
	    }
	    else
	    {
		System.out.print(fmt.I(n,7) + " RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL\n");
		System.out.print("      (" + fmt.E(a,15,4) + "," + fmt.E(b,15,4) + ")\n\n\n");
	    }
	    if (j != 3)
	    {
		System.out.print(" ALOG(X) WAS LARGER" + fmt.I(k1,6) + " TIMES,\n");
		System.out.print("             AGREED" + fmt.I(k2,6) + " TIMES, AND\n");
		System.out.print("        WAS SMALLER" + fmt.I(k3,6) + " TIMES.\n\n\n");
	    }
	    else
	    {
		System.out.print(" ALOG10(X) WAS LARGER" + fmt.I(k1,6) + " TIMES,\n");
		System.out.print("               AGREED" + fmt.I(k2,6) + " TIMES, AND\n");
		System.out.print("          WAS SMALLER" + fmt.I(k3,6) + " TIMES.\n\n\n");
	    }
	    System.out.print(" THERE ARE" + fmt.I(machar.it,4) + " BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER\n\n\n");
	    w = -999.0e0;
	    if (r6 != ZERO)
		w = ALOG(ABS(r6)) / albeta;
	    System.out.print(" THE MAXIMUM RELATIVE ERROR OF" + fmt.E(r6,15,4) + " = " +
			     fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    System.out.print("    OCCURRED FOR X =" + fmt.E(x1,17,6) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    w = -999.0e0;
	    if (r7 != ZERO)
		w = ALOG(ABS(r7)) / albeta;
	    System.out.print(" THE ROOT MEAN SQUARE RELATIVE ERROR WAS" + fmt.E(r7,15,4) + " = " +
			     fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    if (j <= 1)
	    {
		a = SQRT(half);
		b = 15.0e0 / 16.0e0;
	    }
	    else if (j > 2)
	    {
		a = 16.0e0;
		b = 240.0e0;
	    }
	    else
	    {
		a = SQRT(tenth);
		b = 0.9e0;
	    }
	}

	/* special tests */

	System.out.print("1SPECIAL TESTS\n\n\n");
	System.out.print(" THE IDENTITY  ALOG(X) = -ALOG(1/X)  WILL BE TESTED.\n\n");
	System.out.print("        X         F(X) + F(1/X)\n\n");

	for (i = 1; i <= 5; ++i)
	{
	    x = RAN();
	    x = x + x + 15.0e0;
	    y = ONE / x;
	    z = ALOG(x) + ALOG(y);
	    System.out.print(fmt.E(x,15,7) + fmt.E(z,15,7) + "\n\n");
	}

	System.out.print("\n\n TEST OF SPECIAL ARGUMENTS\n\n\n");
	x = ONE;
	y = ALOG(x);
	System.out.print(" ALOG(1.0) = " + fmt.E(y,15,7) + "\n\n\n");
	x = machar.xmin;
	y = ALOG(x);
	System.out.print(" ALOG(XMIN) = ALOG(" + fmt.E(x,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");
	x = machar.xmax;
	y = ALOG(x);
	System.out.print(" ALOG(XMAX) = ALOG(" + fmt.E(x,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");

	/* test of error returns */

	System.out.print("1TEST OF ERROR RETURNS\n\n\n");

	x = -2.0e0;
	System.out.print(" ALOG WILL BE CALLED WITH THE ARGUMENT" + fmt.E(x,15,4) + "\n");
	System.out.print(" THIS SHOULD TRIGGER AN ERROR MESSAGE\n\n\n");
	try
	{
	    y = ALOG(x);
	}
	catch (ArithmeticException e)
	{
	    y = elefunt.errout("ERROR: ALOG(" + x + ") RAISED " + e);
	}
	System.out.print(" ALOG RETURNED THE VALUE" + fmt.E(y,15,4) + "\n\n\n");

	x = ZERO;
	System.out.print(" ALOG WILL BE CALLED WITH THE ARGUMENT" + fmt.E(x,15,4) + "\n");
	System.out.print(" THIS SHOULD TRIGGER AN ERROR MESSAGE\n\n\n");
	try
	{
	    y = ALOG(x);
	}
	catch (ArithmeticException e)
	{
	    y = elefunt.errout("ERROR: ALOG(" + x + ") RAISED " + e);
	}
	System.out.print(" ALOG RETURNED THE VALUE" + fmt.E(y,15,4) + "\n\n\n\n");

	System.out.print(" THIS CONCLUDES THE TESTS\n");
    }

    public static void main(String[] args)
    {
	talog();
    }
}
